PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PHTTPServer Class Reference

A TCP/IP socket for the HyperText Transfer Protocol version 1.0. More...

`#include <http.h>`

Inheritance diagram for PHTTPServer:
[legend]
Collaboration diagram for PHTTPServer:
[legend]

## Public Member Functions
| PHTTPServer ()
| Create a TCP/IP HTTP protocol socket channel. More...
| PHTTPServer (const PHTTPSpace &urlSpace)
virtual PString | GetServerName () const
| Get the name of the server. More...
PHTTPSpace & | GetURLSpace ()
| Get the name space being used by the HTTP server socket. More...
void | SetURLSpace (const PHTTPSpace &space)
| Use a new URL name space for this HTTP socket. More...
virtual PBoolean | ProcessCommand ()
| Process commands, dispatching to the appropriate virtual function. More...
virtual PBoolean | OnGET (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a GET command from a client. More...
virtual PBoolean | OnHEAD (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a HEAD command from a client. More...
virtual PBoolean | OnPOST (const PURL &url, const PMIMEInfo &info, const PStringToString &data, const PHTTPConnectionInfo &conInfo)
| Handle a POST command from a client. More...
virtual PBoolean | OnProxy (const PHTTPConnectionInfo &conInfo)
| Handle a proxy command request from a client. More...
virtual PString | ReadEntityBody ()
| Read the entity body associated with a HTTP request, and close the socket if not a persistent connection. More...
virtual PBoolean | OnUnknown (const PCaselessString &command, const PHTTPConnectionInfo &connectInfo)
| Handle an unknown command. More...
PBoolean | StartResponse (StatusCode code, PMIMEInfo &headers, long bodySize)
| Write a command reply back to the client, and construct some of the outgoing MIME fields. More...
virtual PBoolean | OnError (StatusCode code, const PCaselessString &extra, const PHTTPConnectionInfo &connectInfo)
| Write an error response for the specified code. More...
void | SetDefaultMIMEInfo (PMIMEInfo &info, const PHTTPConnectionInfo &connectInfo)
| Set the default mime info. More...
PHTTPConnectionInfo & | GetConnectionInfo ()
| Get the connection info for this connection. More...
virtual bool | OnCommand (PINDEX cmd, const PURL &url, const PString &args, PHTTPConnectionInfo &connectInfo)
| Called when a request is received. More...

## Protected Member Functions
void | Construct ()
Protected Member Functions inherited from PHTTP
| PHTTP ()
| Create a TCP/IP HTTP protocol channel. More...
| PHTTP (const char *defaultServiceName)
virtual PINDEX | ParseResponse (const PString &line)
| Parse a response line string into a response code and any extra info on the line. More...
Protected Member Functions inherited from PInternetProtocol
| PInternetProtocol (const char *defaultServiceName, PINDEX cmdCount, char const *const *cmdNames)
Protected Member Functions inherited from PIndirectChannel
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
P_INT_PTR | GetOSHandleAsInt () const
int | PXClose ()
| PChannel ()
| Create the channel. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes
PHTTPSpace | urlSpace
PHTTPConnectionInfo | connectInfo
unsigned | transactionCount
PTimeInterval | nextTimeout

## Additional Inherited Members
Public Types inherited from PHTTP
enum | Commands { GET, HEAD, POST, PUT, DELETE, TRACE, OPTIONS, CONNECT, NumCommands }
enum | StatusCode { BadResponse = 1, ContentProcessorError, UnknownTransferEncoding, Continue = 100, SwitchingProtocols, RequestOK = 200, Created, Accepted, NonAuthoritativeInformation, NoContent, ResetContent, PartialContent, MultipleChoices = 300, MovedPermanently, MovedTemporarily, SeeOther, NotModified, UseProxy, BadRequest = 400, UnAuthorised, PaymentRequired, Forbidden, NotFound, MethodNotAllowed, NoneAcceptable, ProxyAuthenticationRequired, RequestTimeout, Conflict, Gone, LengthRequired, UnlessTrue, InternalServerError = 500, NotImplemented, BadGateway, ServiceUnavailable, GatewayTimeout }
Static Public Member Functions inherited from PHTTP
static const PCaselessString & | HostTag ()
static const PCaselessString & | AllowTag ()
static const PCaselessString & | AuthorizationTag ()
static const PCaselessString & | ContentEncodingTag ()
static const PCaselessString & | ContentLengthTag ()
static const PCaselessString & | ContentTypeTag ()
static const PCaselessString & | DateTag ()
static const PCaselessString & | ExpiresTag ()
static const PCaselessString & | FromTag ()
static const PCaselessString & | IfModifiedSinceTag ()
static const PCaselessString & | LastModifiedTag ()
static const PCaselessString & | LocationTag ()
static const PCaselessString & | PragmaTag ()
static const PCaselessString & | PragmaNoCacheTag ()
static const PCaselessString & | RefererTag ()
static const PCaselessString & | ServerTag ()
static const PCaselessString & | UserAgentTag ()
static const PCaselessString & | WWWAuthenticateTag ()
static const PCaselessString & | MIMEVersionTag ()
static const PCaselessString & | ConnectionTag ()
static const PCaselessString & | KeepAliveTag ()
static const PCaselessString & | TransferEncodingTag ()
static const PCaselessString & | ChunkedTag ()
static const PCaselessString & | ProxyConnectionTag ()
static const PCaselessString & | ProxyAuthorizationTag ()
static const PCaselessString & | ProxyAuthenticateTag ()
static const PCaselessString & | ForwardedTag ()
static const PCaselessString & | SetCookieTag ()
static const PCaselessString & | CookieTag ()
Protected Types inherited from PInternetProtocol
enum | StuffState { DontStuff, StuffIdle, StuffCR, StuffCRLF, StuffCRLFdot, StuffCRLFdotCR }
Friends inherited from PObject

## Detailed Description

A TCP/IP socket for the HyperText Transfer Protocol version 1.0.

The server socket thread would continuously call the ProcessCommand() function until it returns false. This will then call the appropriate virtual function on parsing the HTTP protocol.

    PTCPSocket socket(80);
    if (!socket.Listen())
      return;

    PHTTPSpace httpNameSpace;
    httpNameSpace.AddResource(new PHTTPDirectory("data", "data"))

    PHTTServer httpServer(httpNameSpace);
    if (!httpServer.Open(socket))
      return;

    while (httpServer.ProcessCommand())
      ;

## Constructor & Destructor Documentation

PHTTPServer::PHTTPServer | ( |  | ) |

Create a TCP/IP HTTP protocol socket channel.

The form with the single `port` parameter creates an unopened socket, the form with the `address` parameter makes a connection to a remote system, opening the socket. The form with the `socket` parameter opens the socket to an incoming call from a "listening" socket.

PHTTPServer::PHTTPServer | ( | const PHTTPSpace & | urlSpace | ) |

Parameters

  urlSpace | Name space to use for URLs received.

## Member Function Documentation

void PHTTPServer::Construct | ( |  | ) |
| protected

PHTTPConnectionInfo& PHTTPServer::GetConnectionInfo | ( |  | ) |
| inline

Get the connection info for this connection.

References connectInfo.

virtual PString PHTTPServer::GetServerName | ( |  | ) | const
| virtual

Get the name of the server.

Returns
  String name of the server.

PHTTPSpace& PHTTPServer::GetURLSpace | ( |  | ) |
| inline

Get the name space being used by the HTTP server socket.

Returns
  URL name space tree.

References urlSpace.

virtual bool PHTTPServer::OnCommand | ( | PINDEX | cmd,
|  | const PURL & | url,
|  | const PString & | args,
|  | PHTTPConnectionInfo & | connectInfo
| ) |  |
| virtual

Called when a request is received.

By default, this intercepts the GET, HEAD and POST commands and calls OnGET, OnHEAD and OnPOST. For all other command, OnUnknown is called

virtual PBoolean PHTTPServer::OnError | ( | StatusCode | code,
|  | const PCaselessString & | extra,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |
| virtual

Write an error response for the specified code.

Depending on the `code` parameter this function will also send a HTML version of the status code for display on the remote client viewer.

Returns
  true if the connection may persist, false if the connection must close

Parameters

  code | Status code for the error response.
  extra | Extra information included in the response.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnGET | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |
| virtual

Handle a GET command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnHEAD | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |
| virtual

Handle a HEAD command from a client.

The default implemetation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnPOST | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PStringToString & | data,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |
| virtual

Handle a POST command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  data | Variables provided in the POST data.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnProxy | ( | const PHTTPConnectionInfo & | conInfo | ) |
| virtual

Handle a proxy command request from a client.

This will only get called if the request was not for this particular server. If it was a proxy request for this server (host and port number) then the appropriate `OnGET()`, `OnHEAD()` or `OnPOST()` command is called.

The default implementation returns OnError(BadGateway).

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnUnknown | ( | const PCaselessString & | command,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |
| virtual

Handle an unknown command.

Returns
  true if the connection may persist, false if the connection must close

Parameters

  command | Complete command line received.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::ProcessCommand | ( |  | ) |
| virtual

Process commands, dispatching to the appropriate virtual function.

This is used when the socket is acting as a server.

Returns
  true if the request specified persistent mode and the request version allows it, false if the socket closed, timed out, the protocol does not allow persistent mode, or the client did not request it timed out

virtual PString PHTTPServer::ReadEntityBody | ( |  | ) |
| virtual

Read the entity body associated with a HTTP request, and close the socket if not a persistent connection.

Returns
  The entity body of the command

void PHTTPServer::SetDefaultMIMEInfo | ( | PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |

Set the default mime info.

Parameters

  info | Extra MIME information in command.
  connectInfo | Connection information

void PHTTPServer::SetURLSpace | ( | const PHTTPSpace & | space | ) |

Use a new URL name space for this HTTP socket.

Parameters

  space | New URL name space to use.

PBoolean PHTTPServer::StartResponse | ( | StatusCode | code,
|  | PMIMEInfo & | headers,
|  | long | bodySize
| ) |  |

Write a command reply back to the client, and construct some of the outgoing MIME fields.

The MIME fields are not sent.

The `bodySize` parameter determines the size of the entity body associated with the response. If `bodySize` is >= 0, then a ContentLength field will be added to the outgoing MIME headers if one does not already exist.

If `bodySize` is < 0, then it is assumed that the size of the entity body is unknown, or has already been added, and no ContentLength field will be constructed.

If the version of the request is less than 1.0, then this function does nothing.

Returns
  true if requires v1.1 chunked transfer encoding.

Parameters

  code | Status code for the response.
  headers | MIME variables included in response.
  bodySize | Size of the rest of the response.

## Member Data Documentation

PHTTPConnectionInfo PHTTPServer::connectInfo
| protected

Referenced by GetConnectionInfo().

PTimeInterval PHTTPServer::nextTimeout
| protected

unsigned PHTTPServer::transactionCount
| protected

PHTTPSpace PHTTPServer::urlSpace
| protected

Referenced by GetURLSpace().

The documentation for this class was generated from the following file:

- http.h